<template>
  <div class="d-flex flex-col text-left image-chooser">
    <h2 v-if="controls" class="mt-0 ph-2">Pictures</h2>

    <Error v-if="eerror" :error.sync="eerror" class="mh-5 mb-3" round/>

    <div class="img-grid">
      <div v-for="(img, i) of images" :key="i" class="img" :id="`${_uid}-${i}`">
        <img :src="img" @click="onClick(i)">
        <button class="icon-button discard" @click="discard(i)">
          <v-icon name="trash"/>
        </button>
        <button v-if="i !== 0" class="primary set-profile"
          @click="setProfile(i)">
          Set as profile picture
        </button>
      </div>

      <div class="d-flex flex-col add-picture">
        <button class="flex-1 text-pink icon-button" @click="addPicture">
          <v-icon name="plus" scale="1.5"/>
        </button>
      </div>

      <!-- <img v-for="(img, i) of images" :key="i" :src="img"
        @click="(e) => onClick(e, i)"> -->
    </div>

    <div v-if="controls" class="d-flex flex-row mt-5">
      <button class="flex-1 secondary mr-1" @click="$emit('cancel')">
        Cancel
      </button>
      <button class="flex-1 primary ml-1" @click="$emit('done')"
        :disabled="uploading">
        Done
      </button>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    images: {
      type: Array,
      required: true,
    },
    controls: {
      type: Boolean,
      default: true,
    },
    uploading: {
      type: Boolean,
      default: false,
    },
    error: {
      required: false,
      default: null,
    },
  },
  data: () => ({
    _images: [],
    eerror: null,

    _selectedIndex: null,
  }),
  watch: {
    error(to) {
      this.eerror = to;
    },
  },
  methods: {
    onClick(i) {
      let el = document.getElementById(`${this._uid}-${i}`);
      if (!el) return;
      el.classList.toggle('details');
    },
    discard(i) {
      let images = [ ...this.$props.images ];
      images.splice(i, 1);
      this.$emit('update:images', images);
    },
    setProfile(i) {
      let prof = this.$props.images[i];
      let images = [ ...this.$props.images ];
      images.splice(i, 1);
      images.unshift(prof);
      this.$emit('update:images', images);
    },
    addPicture() {
      let el = document.createElement('input');
      el.type = "file";
      el.accept = "image/*";

      el.onchange = () => {
        el;
        let r = new FileReader();

        r.onload = () => {
          let imgs = [ ...this.$props.images, r.result ];
          this.$emit('update:images', imgs);
        };

        r.readAsDataURL(el.files[0]);
      };

      el.click();
    },
  },
  mounted() {
  },
};
</script>

<style scoped>
.img-grid {
  display: grid;
  grid-template-columns: repeat(3, 33.33%);
  grid-auto-rows: 1fr;
  user-select: none;

  width: 600px;
  max-width: 100%;
}

/* .img-grid > div { min-height: 180px; } */

.img {
  /* width: calc(100% / 3 - 1em); */
  margin: .5em;
  position: relative;
  border-radius: 8px;
  overflow: hidden;

  display: flex;
  flex: 0 0 auto;
}

.img button.discard {
  position: absolute;
  top: 6px;
  right: 6px;
  width: 30px;
  height: 30px;

  background: var(--color-pink);
  color: white;
}

.img:not(.details) button {
  display: none;
}

.img button.set-profile {
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  border-radius: 0;
  padding: .5em;
  text-transform: none;
  font-weight: normal;
  font-size: 11pt;
}

.img button.discard .fa-icon { width: 12px; }

.img img {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.image-chooser {
  max-width: 600px;
  position: relative;
}

.add-picture {
  border: 2px dashed var(--color-pink);
  border-radius: 8px;
  margin: .5em;
  min-height: 180px;
}

@media only screen and (max-width: 550px) {
  .img-grid {
    grid-template-columns: repeat(2, 50%);
  }
}
</style>
